#!perl -w
# ==============================================================================
# cp932/Shift_JISƂ̂ use utf8; ͕sv
# ==============================================================================
use File::Temp     qw(tempfile);
use File::Basename qw(basename);
use Getopt::Long   qw(GetOptions);
use Encode         qw(decode encode);
use Tk;
use strict;

my $G_scrname = basename(__FILE__); # XNvg

# ==============================================================================
# /IvVǂݎ
# ==============================================================================
{
  # R}hCl
    my %args = (str=>'', fname=>'', help=>0);
    
  # R}hC擾(G[usage())
    GetOptions(\%args, 'str=s', 'fname=s', 'help') or usage(1);
    
  # -helpwȂusage
    usage(0) if ($args{help});
    
  # str/fnamewGUI[h
    if (($args{str} eq '') or ($args{fname} eq '')) {
        mode_gui(\%args); # GUI[h
    } else {
        mode_cui(\%args); # CUI[h
    }
}

# ==============================================================================
# usage
# ==============================================================================
sub usage {
    my ($ret) = @_;
    
    print "HTMLɕϊ܂B\n";
    print "$G_scrname -str  -fname o̓t@C\n";
    print "    CUI[h: -str, -fnamew莞\n";
    print "    GUI[h: wIvVݎ\n";
    
    exit($ret);
}

# ==============================================================================
# CUI
# ==============================================================================
sub mode_cui {
  # 
    my ($args) = @_;
    
  # s{̂
    my $ret = run(str=>$args->{str}, fname=>$args->{fname}, mode=>'cui');
    
  # ⏕\
    print "INF: $G_scrname: str=$ret->{str}\"\n";
    print "INF: $G_scrname: fname=$ret->{fname}\n";
}

# ==============================================================================
# GUI
# ==============================================================================
sub mode_gui {
  # 
    my ($args) = @_;
    
  # MainWindowIuWFNg擾
    my $o_mw = MainWindow->new();                # IuWFNg擾
    $o_mw->title(decode('cp932',$G_scrname));    # c[^Cg(XNvg)
    $o_mw->optionAdd('*font'=>['Meiryo UI',10]); # ftHgtHg
    $o_mw->resizable(1,0);                       # (width, hight) widtĥ݃TCYύX\
  
  # LabelEBWFbgݒ(EBWFbg֓nf[^̓fR[hutf-8)
    my $o_label_str   = $o_mw->Label(-text=>decode('cp932','-str: \'));
    my $o_label_fname = $o_mw->Label(-text=>decode('cp932','-fname: o̓t@C(ȗ)'));
    
  # EntryEBWFbgݒ(EBWFbg߂f[^̓fR[hutf-8)
    my $str_u8   = ''; # li[ϐ(utf-8z)
    my $fname_u8 = ''; # li[ϐ(utf-8z)
    
    my $o_entry_str   = $o_mw->Entry(-textvariable=>\$str_u8, # i[ϐւ̎Q
                                     -width=>40);
    my $o_entry_fname = $o_mw->Entry(-textvariable=>\$fname_u8, # i[ϐւ̎Q
                                     -width=>40);
    
  # Entrylݒ(̒lcp932̂ߕϊēn)
    $o_entry_str  ->insert(0, decode('cp932',$args->{str}));
    $o_entry_fname->insert(0, decode('cp932',$args->{fname}));
    
  # ButtonEBWFbgݒ(Tu[`t@X̏Tk::UserGuideɍ킹)
  # (EBWFbg߂f[^̓fR[hutf-8)
    my $o_button_run = $o_mw->Button(
                                -text=>'run',           # {^̃eLXg
                                -width=>6,              # {^̕(6)
                                -font=>['Meiryo UI',8], # ftHgƈقȂtHgݒ
                                -command=>sub{          # ֐ւ̎QƂ^
                                              run(
                                                  # [hguiw
                                                  mode=>'gui',
                                                  # ϊĒln
                                                  str=>encode('cp932', $str_u8),
                                                  fname=>encode('cp932', $fname_u8)
                                              )
                                          }
                              );
    
  # EBWFbgzu(ォ珇Ԃɒu)
    my %padxy = (-padx=>8, -pady=>0); # ftHg(x,y)pfBOl
    
    $o_label_str  ->pack(%padxy, -anchor=>'w' ); # Label(\): 
    $o_entry_str  ->pack(%padxy, -fill=>'both'); # Entry(\): windowɍ킹ĐLт
    $o_label_fname->pack(%padxy, -anchor=>'w' ); # Label(o̓t@C): 
    $o_entry_fname->pack(%padxy, -fill=>'both'); # Entry(o̓t@C): windowɍ킹ĐLт
    $o_button_run ->pack(%padxy, -anchor=>'w',   # Button(run): 
                                 -pady=>2     ); # Ō̃EBWFbgȂ̂ypfBO=2
    
  # MainWindowsJn
    MainLoop();
}

# ==============================================================================
# s̖{(w蕶wFHTMLɂăuEU\)
# ==============================================================================
sub run {
  # Ot`
    my %defs = (str=>'', fname=>'', mode=>'cui');
  # Ot
    my %args = (%defs, @_);
    
  # HTMLqAhLgƍč쐬
    my $buf = << "    EOT";
<!doctype html public "-//W3C//DTD HTML 4.01 //EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html lang="ja">
  <head>
    <meta http-equive="Content-Type" content="text/html; charset=Shift_JIS">
    <!-- ̃Rg͕h~p ============================================ -->
    <title>$G_scrname</title>
  </head>
  <body>
    <div style="text-align:center; border-width:1px; border-style:solid">
      <span style="color:blue; font-size:16pt; font-weight:bold;">$args{str}</span>
    </div>
  </body>
</html>
    EOT
  
  # t@Cnh擾
    my $fh;
    if ($args{fname} eq '') {
        ($fh, $args{fname}) = tempfile(UNLINK => 1, SUFFIX => '.html'); # e|t@C
    } else {
        $args{fname} .= '.html' unless ($args{fname} =~ /\.htm[l]*\s*$/);
        open($fh, "> $args{fname}"); # wt@C
    }
  
  # HTMLo
    print $fh $buf;
    
  # t@CnhN[Y
    close($fh);
    
  # GUIsstartWebuEUJ
  # ŏ""̓_~[^CgBXy[Xt@CɑΉ邽
    system('start "" "'.$args{fname}.'"') if ($args{mode} eq 'gui');
    
  # ݂̒l߂
    return(\%args);
}

1;
